.386
.model flat, stdcall
option casemap :none

include Demo.inc

.data
library     db 'Console.dll',0
function    db 'StdOut',0
message     db 'Hello world!',13,10,0
message2    db 'This is a console application.',13,10,0

.data?
hLibrary    dd ?
pFunc       dd ?

fcall       TYPEDEF PTR pr1
StdOut      EQU <fcall PTR pFunc>


.code

start:
    invoke  LoadLibrary,ADDR library            ; Run-Time Dynamic Linking
    mov     hLibrary,eax
    invoke  GetProcAddress,eax,ADDR function    ; get the address of the function StdOut
                                                ; exported by Console.dll
    mov     pFunc,eax
    push    OFFSET message                      ; push the OFFSET of the string to the stack
                                                ; the push & call pair is equivalent to
                                                ; invoke StdOut,ADDR message
    call    eax                                 ; eax holds the address of the function
    invoke  StdOut,ADDR message2                ; pFunc ( the address of StdOut ) is prototyped
                                                ; via "fcall PTR pFunc"
    invoke  FreeLibrary,hLibrary                ; unload the DLL                                                
    invoke  ExitProcess,0

END start

